local myname="ZifnabsEmotor"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={emotor=Me} else ZifnabsMod.emotor=Me end
local fw
local mod
local C
local L
local db
local dbpc

local SOULSTONE_TIME=30*60
local PLAYERNAME=UnitName("player").." "..GetRealmName()
local reaction={precheck={}}
local summon
local state={infight=false,fishing=false}
local unknownspell={}
local widget={}
local last={}

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	fw=fwinfo
	mod=fwinfo.mod
	C=fwinfo.C
	L=fwinfo.L
	db=fwinfo.db
	dbpc=fwinfo.dbpc
	if not db.emotor then db.emotor={cmd={},hesheit={},pet={}, nosexfound={}} end
	
	for cmd,data in pairs(L.emotor.cmd) do
		if not db.emotor.cmd[cmd] then
			db.emotor.cmd[cmd]=data
			mod.f:PrintR(L.msg.cmdinserted,{cmd=cmd})
		end
	end
	for key,data in pairs(L.emotor.hesheit) do
		if not db.emotor.hesheit[key] then
			db.emotor.hesheit[key]=data
			mod.f:PrintR(L.msg.hsiinserted,{key=key})
		end
	end
		
	widget.mute=mod.ui:newControlButton(2,myname.."_Mute",{click=Me.Mute})
	Me:Mute("set",db.gatherer.muted)

	mod.core:Register4Event("PLAYER_REGEN_DISABLED","emotor",Me.PLAYER_REGEN_DISABLED)
	mod.core:Register4Event("PLAYER_REGEN_ENABLED","emotor",Me.PLAYER_REGEN_ENABLED)
	mod.core:Register4Event("UNIT_SPELLCAST_START","emotor",Me.SPELLCAST_START)
	mod.core:Register4Event("UNIT_SPELLCAST_CHANNEL_START","emotor",Me.SPELLCAST_CHANNEL_START)
	mod.core:Register4Event("UNIT_SPELLCAST_CHANNEL_STOP","emotor",Me.SPELLCAST_CHANNEL_STOP)
	mod.core:Register4Event("ONUPDATE","emotor",Me.OnUpdate)

	BINDING_NAME_ZIFNABS_EMOTOR_HI    = L.keybind.emotor.hi
	BINDING_NAME_ZIFNABS_EMOTOR_BYE   = L.keybind.emotor.bye
	BINDING_NAME_ZIFNABS_EMOTOR_SORRY = L.keybind.emotor.sorry
	BINDING_NAME_ZIFNABS_EMOTOR_THANK = L.keybind.emotor.thank
	BINDING_NAME_ZIFNABS_EMOTOR_CHEER = L.keybind.emotor.cheer
	BINDING_NAME_ZIFNABS_EMOTOR_CRY   = L.keybind.emotor.cry  
	BINDING_NAME_ZIFNABS_EMOTOR_SIGH  = L.keybind.emotor.sigh
	BINDING_NAME_ZIFNABS_EMOTOR_WAVE  = L.keybind.emotor.wave
end

function Me:PostInit()
	for name,data in pairs(db.emotor.nosexfound) do
		if not Me:GetSex(name,"initcheck") then 
			if mod.targets.Seen(name) then mod.f:PrintR(L.msg.nosexfound,{target=name})
			else db.emotor.nosexfound[name]="nil" end -- offenbar ein "Falschläufer"
		else
			db.emotor.nosexfound[name]=nil
			mod.f:PrintR(L.msg.sexfound,{target=name})
		end
	end
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate()
	if summon then
		if UnitCreatureFamily("pet")==summon.family then
			if not dbpc.petname then dbpc.petname={} end
			dbpc.petname[summon.slot]=UnitName("pet")
			summon=nil
		elseif time()-summon.start>11 then
			summon=nil
		end
	end
end

-- --------------------------------------------------------------------------------------
-- PLAYER REGEN ENABLED/DISABLED
-- --------------------------------------------------------------------------------------
function Me:PLAYER_REGEN_DISABLED() 
	state.infight=true
	if state.fishing then Me:Command("FISHING_ATTACKED") end
end
function Me:PLAYER_REGEN_ENABLED() state.infight=false end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_START
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_START(who,spellid,rank,more) Me:AnyCast(who,spellid,rank,"cast") end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_CHANNEL_START
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_START(who,spellid,rank,more) Me:AnyCast(who,spellid,rank,"channel") end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_CHANNEL_STOP
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_STOP(who,spellid,rank,more)
	if C.spell[rank]=="FISHING" then state.fishing=false end
end

-- --------------------------------------------------------------------------------------
-- ANY CAST
-- --------------------------------------------------------------------------------------
function Me:AnyCast(who,spellid,rank,casttype)
	local spell=C.spell[rank]
	local list=nil
	local pet=nil
	if who=="player" and spell and db.emotor.cmd[spell] then 
		-- Angeln
		if spell=="FISHING" then
			state.fishing=true
			local x,y,z,pos=mod.loc:GetLoc()
			if not reaction.precheck or not reaction.precheck.FISHING or mod.loc:Distance(pos,reaction.precheck.FISHING.loc)>0.2 or time()-reaction.precheck.FISHING.time>300 then spell="FISHING_1" end
			reaction.precheck.FISHING={time=time(),loc=pos}
		end
		-- Seelenstein setzen
		if spell=="SET_SOULSTONE" then
			mod.scheduler:add(SOULSTONE_TIME-60,"SSS-60","*.mod.hud:write(*.mod.f:Repl(*.L.msg.soulstonefade,{rest=60}),\"SOULSTONEOUT\")")
			mod.scheduler:add(SOULSTONE_TIME-20,"SSS-20","*.mod.hud:write(*.mod.f:Repl(*.L.msg.soulstonefade,{rest=20}),\"SOULSTONEOUT\")")
			mod.scheduler:add(SOULSTONE_TIME-00,"SSS-00","*.mod.hud:write(*.L.msg.soulstonefaded,\"SOULSTONEOUT\")")
			list="SELF"
			for party=1,5,1 do
				if UnitName("party"..party) and UnitName("target")==UnitName("party"..party) then list="TARGET" end
			end
		end
		-- Dämon beschwören
		if string.sub(spell,1,7)=="SUMMON_" then
			local demon=string.sub(spell,8)
			if L.word[demon] then 
				pet=L.word[demon]
				summon={slot=demon,family=pet,start=time()}
				if dbpc.petname and dbpc.petname[demon] then 
					pet=dbpc.petname[demon] 
				end
			end
		end
		Me:Command(spell,nil,list,pet)
	else
		if not C.spell[rank] and not unknownspell[rank] then 
			mod.f:Print((who or "nil").." "..casttype.." rank="..(rank or "nil")..". spellid="..(spellid or "nil")) 
			unknownspell[rank]={casttype=casttype,spellid=spellid}
		end
	end
end

-- --------------------------------------------------------------------------------------
-- COMMAND
-- --------------------------------------------------------------------------------------
function Me:Command(cmd,parm,list,pet)
	cmd=string.upper(cmd)
	list=list or "NOTARGET"
	pet=pet or UnitName("pet") or ""
	local skipemotes=false
	
	-- Pet Aktion
	if cmd=="PET" then
		if not UnitExists("pet") or string.upper(parm)=="PASSIVE" and not state.infight then
			cmd=nil
		else
			if UnitClass("player")==L.word.WARLOCK then 
				cmd="DEMON" 
				-- TODO eventuell noch spezialisieren auf IMP/VOID/SUCCUBUS/FELHOUND
			end
			cmd=cmd.."_"..string.upper(parm)
		end
	end
	
	if not cmd then nothing=nil
	elseif string.sub(cmd,1,1)=="/" then DoEmote(string.sub(cmd,2))
	elseif not db.emotor.cmd[cmd] then mod.f:PrintR(L.msg.unknowncmd,{cmd=cmd})
	elseif db.emotor.muted and not db.emotor.cmd[cmd].unmutable then nothing=nil
	elseif not reaction[cmd] or time()-reaction[cmd].time>=db.emotor.cmd[cmd].option.mute then
		if list=="NOTARGET" and UnitExists("target") and db.emotor.cmd[cmd].TARGET then
			list="TARGET"
			if UnitCanAttack("player","target") and db.emotor.cmd[cmd].ENEMY then list="ENEMY" end
			if list=="ENEMY" and cmd=="THANK" and (state.infight or UnitIsDead("target")) then 
				list="NOTARGET" 
				skipemotes=true
			end
			if UnitIsPlayer("target") then 
				local classify=mod.targets:Classify(UnitName("target"))
				if classify and db.emotor.cmd[cmd][classify] then list=classify end
			end
		end
		local selectedemo=""
		local selectedsay=""
		if math.random(99)<(db.emotor.cmd[cmd].option.react or 100) and db.emotor.cmd[cmd][list] then
			local say=Me:Add2Selectable({},"say",db.emotor.cmd[cmd][list].say,cmd,list)
			local emo=Me:Add2Selectable({},"emo",db.emotor.cmd[cmd][list].emo,cmd,list,skipemotes)
			if db.emotor.cmd[cmd].option.chain then
				local chain=mod.f:Split(db.emotor.cmd[cmd].option.chain,"[.]",2)
				if not chain[2] then chain[2]=list end
				if db.emotor.cmd[chain[1]] and db.emotor.cmd[chain[1]][chain[2]] then
					say=Me:Add2Selectable(say,"say",db.emotor.cmd[chain[1]][chain[2]].say,cmd,list)
					emo=Me:Add2Selectable(emo,"emo",db.emotor.cmd[chain[1]][chain[2]].emo,cmd,list,skipemotes)
				end
			end
			local language=nil -- TODO irgendwo einen Sprachenschalter einbauen?
			if #say>0 then selectedsay=Me:TakeRandomFrom(say,"say."..cmd.."."..list) else mod.f:PrintR(L.msg.emptylist,{list=cmd.."."..list..".say"}) end
			if #emo>0 then selectedemo=Me:TakeRandomFrom(emo,"emo."..cmd.."."..list) else mod.f:PrintR(L.msg.emptylist,{list=cmd.."."..list..".emo"}) end
			local concat=string.find(selectedsay,"&&")
			if concat then
				selectedemo=string.sub(selectedsay,concat+2)
				if concat>1 then selectedsay=string.sub(selectedsay,1,concat-1) else selectedsay="" end
			end
			selectedsay=Me:ReplaceKeysWithSex(selectedsay)
			selectedemo=Me:ReplaceKeysWithSex(selectedemo)
			
			local race=UnitRace("target") or UnitCreatureFamily("target") or UnitClass("target") or "Whatever"
			if selectedsay then selectedsay=mod.f:Repl(selectedsay,{[".race"]=race,["pet"]=pet}) end
			if selectedemo then selectedemo=mod.f:Repl(selectedemo,{[".race"]=race,["pet"]=pet}) end
			
			
			if string.sub(selectedemo,1,1)=="/" then DoEmote(string.sub(selectedemo,2)) else SendChatMessage(selectedemo,"EMOTE") end
			local channel="SAY"
			if strlower(strsub(selectedsay,1,3))=="/y " then
				selectedsay=strtrim(strsub(selectedsay,3))
				channel="YELL"
			end
			SendChatMessage(selectedsay,channel,GetLanguageByIndex(language or 1))

			local x,y,z,pos=mod.loc:GetLoc()
			reaction[cmd]={time=time(),loc=pos}
		end
	end
end

function Me:TakeRandomFrom(tbl,lastid)
	local take=tbl[math.random(#tbl)].text
	if not take then 
		print("EMOTOR: TAKE=NIL for "..lastid.." ("..#tbl..")")
		take=""
	end
	if not last[lastid] then last[lastid]={} end
	last[lastid][take]=true
	return take
end

-- --------------------------------------------------------------------------------------
-- ADD TO TABLE
-- --------------------------------------------------------------------------------------
function Me:Add2Selectable(tbl,emosay,fromtbl,cmd,list,skipemotes)
	local lastid=emosay.."."..cmd.."."..list
	if not last[lastid] then last[lastid]={} end
	local excluded=0
	for nr,entry in pairs(fromtbl) do
		if (not entry.exclude or not entry.exclude[PLAYERNAME]) and (not entry.select or entry.select[PLAYERNAME]) then		
			if not last[lastid][entry.text] and (not skipemotes or string.sub(entry.text,1,1)~="/") then 
				tbl[1+#tbl]=entry  
			else 
				excluded=excluded+1
			end
		end
	end
	if #tbl<=1 then
		if excluded==0 or #tbl==0 then last[lastid]={} else last[lastid]={[tbl[1]]=true} end
	end
	return tbl
end

-- --------------------------------------------------------------------------------------
-- REPLACE KEYS WITH SEX
-- --------------------------------------------------------------------------------------
function Me:ReplaceKeysWithSex(text)
	local playersex=UnitSex("player")	
	local targetsex=playersex
	local targetname=playername
	local cursorsex=playersex
	local cursorname=playername
	-- Geschlecht des Targets ermitteln
	if UnitExists("target") then 
		targetname=UnitName("target")
		targetsex=UnitSex("target") 
		if targetsex==1 then targetsex=Me:GetSex(targetname,"target") end -- sächlich, ist default für alle Kreaturen
		targetname=Me:Peal(targetname,true)
	end
	
	-- Geschlecht des Cursorziels ermitteln
	cursorname=getglobal("GameTooltipTextLeft1"):GetText()
	if cursorname==nil then 
		cursorname=targetname 
		cursorsex=targetsex
	else
		cursorsex=Me:GetSex(cursorname)
		cursorname=Me:Peal(cursorname)
	end

	-- Namen im Text ersetzen
	text=(text or "")
	text=mod.f:Repl(text,{["*"]=playername,["."]=targetname,["#"]=cursorname})

	-- Schlüsselworte im Text ersetzen
	for key,repl in pairs(db.emotor.hesheit) do
local before=text	
		text=mod.f:Repl(text,{["*"..key]=repl[playersex],["."..key]=repl[targetsex],["#"..key]=repl[cursorsex]})
	end
	return text
end

-- --------------------------------------------------------------------------------------
-- GET SEX
-- --------------------------------------------------------------------------------------
function Me:GetSex(target,sexparm)
	local sex=1 -- Default ist sächlich
	local found=nil
	local word1,word2=strsplit(" ",strlower(target),2)
	if UnitName("pet")==target then
		sex=2 -- Pets sind normalerweise männlich, außer Sukkubus
		if UnitCreatureFamily("pet")==L.word.SUCCUBUS then sex=3 end
		found=true
	end
	
	if db.targets.list[target] and db.targets.list[target].player and db.targets.list[target].sex then
		sex=db.targets.list[target].sex
		found=true
	end
	
	-- vorangestellte Worte durchsuchen (z.B. Drache der ..., Akolyth der...)
	if word2 and not found then
		local search=L.emotor.sexprefix
		for i=1,#search,1 do
			if strfind(word1,search[i][2])==1 and not found then
				found="yes"
				sex=search[i][1]
			end
		end
		search=L.emotor.sexsufix
		for i=1,#search,1 do
			if strsub(word1,strlen(word1)-strlen(search[i][2])+1)==search[i][2] and not found then
				found="yes"
				sex=search[i][1]
			end
		end
	end
	
	-- Wortendungen durchsuchen
	word2=strlower(target)
	search=L.emotor.sexsufix
	for i=1,#search,1 do
		if strsub(word2,strlen(word2)-strlen(search[i][2])+1)==search[i][2] and not found then
			found="yes"
			sex=search[i][1]
		end
	end
	
	-- Letzte Wahl: Wenn es um "target" geht und das nicht als sächlich gekennzeichnet ist, DAS übernehmen
	if not found and sexparm=="target" and UnitSex("target")~=1 then
		sex=UnitSex("target") 
		found=sex
	end
	
	if not found then
		if not db.emotor.nosexfound[target] then mod.f:PrintR(L.msg.nosexfound,{target=target}) end
		if sexparm~="initcheck" then 
			if not db.emotor.nosexfound[target] then db.emotor.nosexfound[target]={last=0,count=0} end
			db.emotor.nosexfound[target]={last=time(),count=1+db.emotor.nosexfound[target].count}
		end
	else
		if sexparm=="initcheck" then db.emotor.nosexfound[target]=nil end
	end
	if sexparm=="initcheck" then sex=found end
	return sex
end

-- --------------------------------------------------------------------------------------
-- GET SEX
-- --------------------------------------------------------------------------------------
function Me:Peal(name,target)
	if target then
		local word=mod.f:Split(name," ",4)
		if #word==4 then name=word[2]
		elseif #word==3 then name=word[1]
		elseif #word==2 then
			if UnitCanAttack("target","player") then name=word[2] end
		end
	else
--	local prefix,rest=strsplit(" ",name,2)
--	if rest then
--		local erase=L.emotor.eraseprefix
--		for i=1,#erase,1 do
--			if strlower(prefix)==erase[i] then name=rest end
--		end
--	end
	
--	local parse={strsplit(" ",name)}
--	if #parse==2 then name=parse[2] end

	-- Suffix entfernen ("vorkommen", "pflanze", "ader"...)
		local erase=L.emotor.erasesufix
		for i=1,#erase,1 do
			if strsub(name,strlen(name)-strlen(erase[i])+1)==erase[i] then
				name=strsub(name,1,strlen(name)-strlen(erase[i]))
			end
		end
	end
	return name
end

-- --------------------------------------------------------------------------------------
-- MUTE
-- --------------------------------------------------------------------------------------
function Me:Mute(set,tovalue)
	local iconname="Interface/AddOns/Zifnabs/Icons/Buttons/"
	if set~="set" then tovalue=(not db.emotor.muted) end
	db.emotor.muted=tovalue
	if tovalue then 
		iconname=iconname.."muted.tga" 
		widget.mute.tooltipText=L.msg.muted
	else 
		iconname=iconname.."unmuted.tga" 
		widget.mute.tooltipText=L.msg.unmuted
	end
	widget.mute:SetNormalTexture(iconname)
end