local ZifnabsRelease="r191009a" 
local myname="ZifnabsCore"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={core=Me} else ZifnabsMod.core=Me end

ZifnabsDB={}
ZifnabsDBpC={}

local initialize=0
local C
local L
local db
local dbpc
local mod

local event={}
local unknown_events={}
local widget={}

Me:SetScript("OnEvent",function(this,event,arg1,arg2,arg3,arg4) Me:OnEvent(event,arg1,arg2,arg3,arg4) end)
Me:SetScript("OnUpdate",function(self,elapsed) Me:OnUpdate(self,elapsed) end)
Me:RegisterEvent("VARIABLES_LOADED")

BINDING_HEADER_ZIFNABS = "Zifnabs"
SLASH_ZIFNABS1 = "/z"
SlashCmdList["ZIFNABS"]=function (cmd) Me:SlashCommand(cmd) end

-- --------------------------------------------------------------------------------------
-- INITIALIZE phase 1: VARIABLES_LOADED
-- --------------------------------------------------------------------------------------
function Me:VARIABLES_LOADED() 
	if not ZifnabsDB.dbinit then ZifnabsDB.dbinit=time() end
	if not ZifnabsDBpC.dbinit or ZifnabsDBpC.dbinit<ZifnabsDB.dbinit then ZifnabsDBpC={dbinit=time()} end
	initialize=1 
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE and initialize phase 2
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(caller,elapsed)
	if initialize==2 then Me:OnEvent("ONUPDATE",elapsed)
	elseif initialize==1 and GetDefaultLanguage("player") and GetNumLanguages() then 		
		local fwinfo={framework="Zifnabs",release=ZifnabsRelease,L=ZifnabsL,db=ZifnabsDB,dbpc=ZifnabsDBpC,mod=ZifnabsMod,C=ZifnabsConstants}
		fwinfo.RETAIL=false
--		if (ShowingCloak or Me.CheckRetail)()=="RETAIL" then fwinfo.RETAIL=true end
--		if fwinfo.RETAIL then mod.f:Print("WoW RETAIL") else mod.f:Print("WoW CLASSIC") end
		C=fwinfo.C
		L=fwinfo.L
		db=fwinfo.db
		dbpc=fwinfo.dbpc
		mod=fwinfo.mod
		mod.f:Initialize(fwinfo)
		mod.ui:Initialize(fwinfo)
		fwinfo.frame=mod.ui:newFrame(myname.."Frame",80,32,UIParent,"CENTER","CENTER",0,200,{transparent=true,mainframe=true})
		mod.scheduler:Initialize(fwinfo)
		for name,fwmod in pairs(mod) do
			if name~="core" and name~="f" and name~="ui" and fwmod.Initialize then fwmod:Initialize(fwinfo) end
		end
		for name,fwmod in pairs(mod) do 
			if fwmod.PostInit then fwmod:PostInit() end
		end
		widget.config=mod.ui:newControlButton(1,myname.."_Config",{click=Me.Click,tt="Configure Zifnabs"})
		widget.config:SetNormalTexture("Interface/AddOns/Zifnabs/Icons/Buttons/config.tga")
		initialize=2
		mod.f:PrintR(L.msg.initialized,{fw=fwinfo.framework,release=fwinfo.release})
	end
end
function Me:CheckRetail() return "RETAIL" end

-- --------------------------------------------------------------------------------------
-- ON EVENT
-- --------------------------------------------------------------------------------------
function Me:OnEvent(eventname,arg1,arg2,arg3,arg4)
	if eventname=="VARIABLES_LOADED" then Me:VARIABLES_LOADED()
	elseif event[eventname] then
		for fwmod,info in pairs(event[eventname]) do
			if info.active and info.method then 
				info.method(does_not_get_to_method,arg1,arg2,arg3,arg4) 
			end
		end
	elseif not unknown_events[eventname] then 
		mod.f:PrintR(L.msg.unknownevent,{event=eventname})
		unknown_events[eventname]=(unknown_events[eventname] or 0)+1
	end
end

-- --------------------------------------------------------------------------------------
-- REGISTER FOR EVENT
-- --------------------------------------------------------------------------------------
function Me:Register4Event(eventname,modname,method)
	if eventname~="ONUPDATE" and eventname~="TICK" then Me:RegisterEvent(eventname) end
	if not event[eventname] then event[eventname]={} end
	event[eventname][modname]={active=true,method=method}
	if not method then mod.f:Print("NO METHOD TO REGISTER FOR "..eventname..":"..modname,nil,nil,"ff0000") end
end

-- --------------------------------------------------------------------------------------
-- DE-REGISTER FOR EVENT
-- --------------------------------------------------------------------------------------
function Me:DeRegister4Event(eventname,modname)
	if event[eventname] and event[eventname][modname] then event[eventname][modname]=nil end
	local count=0
	for m,dummy in pairs(event[eventname]) do 
		if dummy~=nil then count=count+1 end
	end
	if count==0 then 
		event[eventname]=nil 
		if eventname~="ONUPDATE" and eventname~="TICK" then Me:DeRegisterEvent(eventname) end
	end
end

-- --------------------------------------------------------------------------------------
-- SLASH COMMANDS
-- --------------------------------------------------------------------------------------
function Me:SlashCommand(cmd,parm)
	local parse=mod.f:Split(cmd," ",2)
	cmd=string.upper(parse[1] or "")
	parm=parse[2]
	if cmd=="ACQ" then
		local AQUIRETEXT="{rt1}Haus Kerlait{rt1} sucht wieder Mitglieder. Bei uns stehen Spielspaß, Freundlichkeit und Rollenspiel im Vordergrund. Bei uns kannst du questen und quatschen in angenehmer Runde und auch mal nette RP-Events erleben. Bei Interesse bitte anflüstern."
		SendChatMessage(AQUIRETEXT,"CHANNEL",nil,1)
	elseif cmd=="DEBUG" then
		mod.f:Print("No Debug available")
	elseif cmd=="SCHEDULE" and parm then 
		parse=mod.f:Split(parm," ",2)
		mod.scheduler:Remind(tonumber(parse[1]),parse[2])
	elseif cmd=="SCHEDULE" then
		mod.scheduler:list()
	elseif cmd=="RELOAD" then
		if string.upper(parm or "")=="RESETDB" then
			ZifnabsDB=nil
			ZifnabsDBpC=nil
		elseif L.emotor.cmd[string.upper(parm or "")] then db.emotor.cmd[string.upper(parm or "")]=nil
		elseif string.upper(parm or "")=="EMOTOR" then db.emotor.cmd={}
		end
		ReloadUI()
	elseif cmd~="" then 
		mod.emotor:Command(cmd,parm)
	end
end
